unit MyInfonew3;

interface

uses
 Windows, SysUtils, Forms, SHLOBJ, registry, printers, MMSYSTEM, ComCtrls,
 Buttons, Dialogs, Classes, Controls, StdCtrls;

type
  TForm1 = class(TForm)
    RAM: TGroupBox;
    ProcMem: TLabel;
    TotalMem: TLabel;
    FreeMem: TLabel;
    TotVirtual: TLabel;
    FreeVirtual: TLabel;
    bios: TLabel;
    Disk: TLabel;
    ddisk: TLabel;
    ddisktotal: TLabel;
    diskTotal: TLabel;
    AMD: TGroupBox;
    Proisv: TLabel;
    Speed: TLabel;
    Tip: TLabel;
    kolich: TLabel;
    Clas: TLabel;
    forma: TGroupBox;
    num1: TLabel;
    num2: TLabel;
    platform: TLabel;
    all: TLabel;
    Comp: TLabel;
    admin: TLabel;
    pathes: TGroupBox;
    desktop: TLabel;
    stprog: TLabel;
    mydocs: TLabel;
    start: TLabel;
    BitBtn1: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn2: TBitBtn;
    Raznoe: TGroupBox;
    Sound: TLabel;
    Print: TLabel;
    Displ: TLabel;
    Plata: TLabel;
    StatusBar1: TStatusBar;
    Save: TSaveDialog;
    procedure SaveToFile(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure create(Sender: TObject);
  private
    { Private declarations }
  public
  procedure DisplayHint(Sender: TObject);
    { Public declarations }
  end;

var
  Form1: TForm1;
  yo: string;
implementation

{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
/////////////////////////////////////////////////////////////////////////////////
//    
// CPU Speed 1.0, Copyright (c) 1998 Erik Salaj, erik@dodo.sk
/////////////////////////////////////////////////////////////////////////////////
function GetCPUSpeed:string;
const
  DelayTime = 500;
var
  TimerHi, TimerLo: DWORD;
  PriorityClass, Priority: Integer;
  Speed:Double;
begin
  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);

  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);

  Sleep(10);
  asm
    dw 310Fh
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  Sleep(DelayTime);
  asm
    dw 310Fh
    sub eax, TimerLo
    sbb edx, TimerHi
    mov TimerLo, eax
    mov TimerHi, edx
  end;

  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);

  Speed := TimerLo / (1000.0 * DelayTime);
  result:= Format('%f ', [Speed])
end;
/////////////////////////////////////////////////////////////////////////////////
//   ,         -
/////////////////////////////////////////////////////////////////////////////////
procedure GetMemStatus(var MemUse,MemPhysTotal,MemPhysFree,
                           MemVirtTotal,MemVirtFree:string);
var
  MS: TMemoryStatus;
begin
  MS.dwLength := SizeOf(MS);
  GlobalMemoryStatus(MS);
    MemUse:=inttostr(MS.dwMemoryLoad)+'%';
    MemPhysTotal:=inttostr(MS.dwTotalPhys div 1024)+' ';
    MemPhysFree:=inttostr(MS.dwAvailPhys div 1024)+' ';
    MemVirtTotal:=inttostr(MS.dwTotalVirtual div 1024)+' ';
    MemVirtFree:=inttostr(MS.dwAvailVirtual div 1024)+' ';
end;
/////////////////////////////////////////////////////////////////////////////////
//  , , -    
/////////////////////////////////////////////////////////////////////////////////
procedure GetSysInfo(var ProcVender, ProcLevel, ProcClass, ProcNum, BiosVer:string);
var
  SI: TSystemInfo;
  s1:tstringlist;
  i:integer;
  R:TRegistry;
begin
  GetSystemInfo(SI);
  ProcNum:=IntToStr(Si.dwNumberOfProcessors);
  R:=TRegistry.Create;
  with R do
    begin
     RootKey:=HKEY_LOCAL_MACHINE;
     OpenKey('\Hardware\Description\System\CentralProcessor\0',false);
     ProcLevel:=ReadString('Identifier');
     ProcVender:=ReadString('VendorIdentifier');
     OpenKey('\Enum\Root\',false);
     if HasSubKeys then
       begin
        S1:=TStringList.Create;
        GetKeyNames(S1);
        for i:=0 to S1.Count-1 do
          begin
           OpenKey('\Enum\root\'+s1[i]+'\0000\',false);
           if ReadString('BIOSVersion')<>'' then BiosVer:=ReadString('BIOSVersion');
          end;
        S1.free;
       end;
     R.Free;
      case Si.wProcessorLevel of
        3: ProcClass := '80386';
        4: ProcClass := '80486';
        5: ProcClass := 'Pentium';
        6: ProcClass := 'Pentium Pro';
      end;
  end;
end;

/////////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////////

function GetMonitorInfo: string;
var
  R:TRegistry;
begin
  R:=TRegistry.Create;
  with R do
    begin
     RootKey:=HKEY_LOCAL_MACHINE;
     OpenKey('\config\0001\Display\Settings',false);
      result:=ReadString('Resolution');
  end;
end;



/////////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////////
function GetPlatform:string;
var
  VI: TOSVersionInfo;
begin
  VI.dwOSVersionInfoSize := SizeOf(VI);
  GetVersionEx(VI);
    case VI.dwPlatformID of
      VER_PLATFORM_WIN32S: result :='Windows 3.1x running Win32s';
      VER_PLATFORM_WIN32_WINDOWS: result :='Windows 9x';
      VER_PLATFORM_WIN32_NT: result :='Windows NT';
    end;
  end;


/////////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////////
function GetOSVer:string;
var
  VI: TOSVersionInfo;
begin
  VI.dwOSVersionInfoSize := SizeOf(VI);
  GetVersionEx(VI);
  result := Format('%d.%d', [VI.dwMajorVersion, VI.dwMinorVersion]);
  end;


  

/////////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////////
function GetOSBuild:string;
var
  VI: TOSVersionInfo;
begin
  VI.dwOSVersionInfoSize := SizeOf(VI);
  GetVersionEx(VI);
  result := Format('%d', [LoWord(VI.dwBuildNumber)]);
  end;


/////////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////////
Function checkaudiocard: boolean;
Begin
 result:=waveoutgetnumdevs>0;
end;

/////////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////////
function GetPrintInfo:string;
begin
  if Printer.Printers.Count>0 then
  result :=Printer.Printers[Printer.PrinterIndex]
  else result := '';
end;
/////////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////////

function GetCompName: string;
var
  R:TRegistry;
begin
  R:=TRegistry.Create;
  with R do
    begin
     RootKey:=HKEY_LOCAL_MACHINE;
     OpenKey('\System\CurrentControlSet\Control\ComputerName\ComputerName',false);
     result := ReadString('ComputerName');
  end;
end;

/////////////////////////////////////////////////////////////////////////////////
//        Internet
/////////////////////////////////////////////////////////////////////////////////
function GetUser: string;
var
  R:TRegistry;
begin
  R:=TRegistry.Create;
  with R do
    begin
     RootKey:=HKEY_LOCAL_MACHINE;
      OpenKey('\System\CurrentControlSet\Control',false);
      result := ReadString('Current User');
  end;
end;

/////////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////////

function GetDateOfSetup: string;
var
  R:TRegistry;
begin
  R:=TRegistry.Create;
  with R do
    begin
     RootKey:=HKEY_LOCAL_MACHINE;
     OpenKey('\Enum\Root\*PNP0C01\0000',false);
      Result := ReadString('BIOSDate');
  end;
end;


/////////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////////

function GetPaths (const FolderID: Integer): String;
var
  pidl: PItemIDList;
  Buffer: array[0..MAX_PATH-1] of Char;
begin

  Result := '';
  if SUCCEEDED(SHGetSpecialFolderLocation(0, FolderID, pidl)) then begin
    if SHGetPathFromIDList(pidl, Buffer) then
      Result := Buffer;
  end;
end;


const
g = ': ';
f = '   ';
t = '   ';
var
one, two, three, four, five: string;
sr: Tsearchrec;
a: pchar;
begin

Speed.caption := ': ' + GetCPUSpeed;

GetSysInfo(one, two, three, four, five);
Proisv.Caption := ': ' + one;
Tip.Caption := ': ' + two;
Clas.Caption := ': ' + three;
kolich.caption := ': ' + four;
bios.caption := 'BIOS: ' + five;

GetMemStatus(one, two, three, four, five);
ProcMem.caption := '  : ' + one;
TotalMem.Caption := '  : ' + two;
FreeMem.Caption := '  : ' + three;
TotVirtual.Caption := '  : ' + four;
FreeVirtual.Caption := '  : ' + five;

platform.Caption := ': ' + getPlatform;
num1.Caption := ': ' + GetOSVer ;
num2.Caption := ' : ' + GetOSbuild;
one := GetOSVer;
if one = '4.10' then begin
if getOSbuild = '2222' then
all.Caption := g + 'Windows 98 Second Edition' else
all.Caption := g + 'Windows 98' end;
if one = '4.90' then
all.Caption := g + 'Windows Millennium Edition';
if one = '4.00' then
if GetOSbuild = '1111' then
all.Caption := g + 'Windows 95 OSR 2' else
all.Caption := g + 'Windows 95';
if one = '5.00' then begin
 all.Caption := g + 'Windows 2000' end;
if all.Caption = '' then
all.Caption := g + 'Windows NT 4.0';

if diskfree(3) <> -1 then begin
disk.Caption := f + ': ' + inttostr(diskfree(3) div 1024) + ' ';
diskTotal.Caption := t + ': ' + inttostr(disksize(3) div 1024) + ' ';
end;

if diskfree(4) <> -1 then begin
 if disk.Caption = '' then begin
 disk.Caption := f + 'D: ' + inttostr(diskfree(4) div 1024) + ' ';
 diskTotal.Caption := t + 'D: ' + inttostr(disksize(4) div 1024) + ' ';
 end else begin
 ddisk.Caption := f + 'D: ' + inttostr(diskfree(4) div 1024) + ' ';
 ddisktotal.Caption := t + 'D: ' + inttostr(disksize(4) div 1024) + ' ';
 end;
end else begin
 ddisk.Caption := '';
 ddiskTotal.Caption := '' end;

if checkaudiocard then
sound.Caption := ': ';

print.Caption := ': ' + GetPrintInfo;

displ.Caption := ' : ' + GetMonitorInfo +  ' ';

yo := Getcompname;
Comp.Caption := ' : ' + yo;
admin.Caption := ' : ' + getuser;

Plata.Caption := ' : ' + GetDateOfSetup;

//findfirst(adres + '\*.dll', faanyfile, sr);
//dat.Caption := ' : ' + datetostr(filedatetodatetime(sr.Time));
//findclose(sr);

desktop.Caption := ' : ' + GetPaths(0);
stprog.Caption := ' "": ' + GetPaths(2);
mydocs.Caption := ' : ' + GetPaths(5);
start.Caption := ' "": ' + GetPaths(6);

//////////////////////////////////
//////////////////////////////////
end;

procedure TForm1.SaveToFile(Sender: TObject);
var
month: string;
y, m, d: word;
Log: Tstringlist;
begin
if procmem.Caption = '' then
application.MessageBox('   .',
':  ', mb_ok + mb_iconstop) else begin
save.filename := '  ' + yo;
if save.Execute then begin
decodedate(now, y, m, d);
case m of
1: month := '';
2: month := '';
3: month := '';
4: month := '';
5: month := '';
6: month := '';
7: month := '';
8: month := '';
9: month := '';
10: month := '';
11: month := '';
12: month := '';
end;
Log := Tstringlist.create;
Log.Add('      ***  "' + yo + '" ' +
inttostr(d) + ' ' + month + ' ' + inttostr(y) + ' ***');
Log.Add('');
Log.Add('   :');
Log.Add(procmem.Caption);
Log.Add(totalmem.Caption);
Log.Add(freemem.Caption);
Log.Add(totvirtual.Caption);
Log.Add(freevirtual.Caption);
Log.Add(bios.Caption);
if disk.Caption <> '' then begin
Log.Add(disk.Caption);
Log.Add(disktotal.Caption) end;
if ddisktotal.Caption <> '' then begin
Log.Add(ddisk.Caption);
Log.Add(ddisktotal.Caption) end;
Log.Add('');
Log.Add('   :');
Log.Add(proisv.Caption);
Log.Add(kolich.Caption);
Log.Add(tip.Caption);
Log.Add(clas.Caption);
Log.Add(speed.Caption);
Log.Add('');
Log.Add('   :');
Log.Add(num1.Caption);
Log.Add(num2.Caption);
Log.Add(platform.Caption);
Log.Add(all.Caption);
Log.Add(comp.Caption);
Log.Add(admin.Caption);
Log.Add('');
Log.Add('   :');
Log.Add(desktop.Caption);
Log.Add(stprog.Caption);
Log.Add(mydocs.Caption);
Log.Add(start.Caption);
Log.Add('');
Log.Add('   :');
Log.Add(sound.Caption);
Log.Add(print.Caption);
Log.Add(displ.Caption);
Log.Add(plata.Caption);
Log.Add('');
Log.Add('------------------------------');
Log.Add('  PC Info 1.1   , 2001');
Log.Add('http://shafff.by.ru/');
Log.Add('mailto:20khz@ukr.net');
log.SaveToFile(save.FileName);
Log.Free;
end;
end;
end;

procedure TForm1.create(Sender: TObject);
begin
Application.onHint := DisplayHint;

end;

procedure TForm1.DisplayHint(Sender: TObject);
begin
  Statusbar1.SimpleText := GetLongHint(Application.Hint);
end;



end.

